package Extensions;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;
import java.io.*;
import android.app.Activity;
import android.content.Intent;
import Actions.CActExtension;
import Application.CRunApp;
import Conditions.CCndExtension;
import Expressions.CValue;
import RunLoop.CCreateObjectInfo;
import Runtime.Log;
import Runtime.MMFRuntime;
import Services.CBinaryFile;
import Services.CServices;
import Frame.CLayer;
import Objects.CExtension;
import Objects.CObject;
import RunLoop.CRun;

import Runtime.SurfaceView;
import android.view.PixelCopy;
import android.view.PixelCopy.OnPixelCopyFinishedListener;
import android.graphics.Bitmap;
import android.view.View;
import android.os.Environment;
import android.content.Intent;
import android.net.Uri;
import androidx.core.content.FileProvider;
import android.content.ActivityNotFoundException;

import android.widget.Toast;

public class CRunscreen_shot extends CRunExtension {
    public CRunscreen_shot () {
    }
	@Override 
	public int getNumberOfConditions(){
		return 0;
	}
    @Override
    public boolean createRunObject(CBinaryFile file, CCreateObjectInfo cob, int version) {
        return false;
    }
    @Override
    public void destroyRunObject(boolean bFast) {
    }
    @Override
    public void action (int num, CActExtension act){
        switch (num){
        	case 0: // screen_shot
        		screen_shot( act.getParamExpString(rh, 0) );
         		break;
         	case 1: // send twitter app
         		send_twitter( act.getParamExpString(rh, 0) );
         		break;
        }
        return;
    }
    // -------------------------------------------------------------------------
    public static Bitmap tmp_bitmap ;
    public static String save_path ;
    public void screen_shot(String path){
    	SurfaceView view = SurfaceView.inst;
    	save_path = path;
		tmp_bitmap = Bitmap.createBitmap(view.getWidth(), view.getHeight(), Bitmap.Config.ARGB_8888);
		PixelCopy.request(view, tmp_bitmap, onPix_listener , view.getHandler());
    }
    public OnPixelCopyFinishedListener onPix_listener = new OnPixelCopyFinishedListener(){
		@Override
	    public void onPixelCopyFinished(int result) {
			if (result != PixelCopy.SUCCESS) {
			    Toast.makeText( MMFRuntime.inst.getApplicationContext() , "Failed to screen shot", Toast.LENGTH_SHORT).show();
			    return;
			}
			try {
			    //try (FileOutputStream out = new FileOutputStream(Environment.getExternalStorageDirectory() +"/"+ save_path)) {
			    try (FileOutputStream out = new FileOutputStream( MMFRuntime.inst.getExternalFilesDir(Environment.DIRECTORY_DCIM) +"/"+ save_path)) {
			    	Log.Log( MMFRuntime.inst.getExternalFilesDir(Environment.DIRECTORY_DCIM) +"/"+ save_path );
			        tmp_bitmap.compress(Bitmap.CompressFormat.PNG, 100, out);
	            	tmp_bitmap.recycle();
	            	out.close();
			    }
			} catch (Exception e) {
				Log.Log( e.toString() );
			}
	    }
    };
    // -------------------------------------------------------------------------
    public static String send_text ;
    public void send_twitter(String text){// put text
    	send_text = text;
    	SurfaceView view = SurfaceView.inst;
    	save_path = "tmp_screen.png";
		tmp_bitmap = Bitmap.createBitmap(view.getWidth(), view.getHeight(), Bitmap.Config.ARGB_8888);
		
		OnPixelCopyFinishedListener onPix_listener_tmp = new OnPixelCopyFinishedListener(){
			@Override
		    public void onPixelCopyFinished(int result) {
				if (result != PixelCopy.SUCCESS) {
				    Toast.makeText( MMFRuntime.inst.getApplicationContext() , "Failed to screen shot", Toast.LENGTH_SHORT).show();
				    return;
				}
				try {
					File shareImgPath = new File( MMFRuntime.inst.getFilesDir(), "files");
					shareImgPath.mkdir();
					
					File shareImg = new File( shareImgPath, save_path );
					
				    try (FileOutputStream out = new FileOutputStream( shareImg )) {
				        tmp_bitmap.compress(Bitmap.CompressFormat.PNG, 100, out);
		            	tmp_bitmap.recycle();
		            	out.close();
				    }
				    
   					Uri contentUri = FileProvider.getUriForFile( MMFRuntime.inst , MMFRuntime.inst.getPackageName() + ".fileprovider" , shareImg);
					
					Intent intent = new Intent();
					intent.setAction(Intent.ACTION_SEND);
					intent.setPackage("com.twitter.android");
					intent.setType("image/png");
					intent.putExtra(Intent.EXTRA_TEXT, send_text);
					intent.putExtra(Intent.EXTRA_STREAM, contentUri);
					
					try {
						MMFRuntime.inst.startActivityForResult(intent,1);
				    } catch (ActivityNotFoundException e) {
    					Toast.makeText( MMFRuntime.inst.getApplicationContext() , "Twitter Application not installed", Toast.LENGTH_SHORT).show();
					}
				    
				} catch (Exception e) {
					Log.Log( e.toString() );
				}
		    }
		};
		PixelCopy.request(view, tmp_bitmap, onPix_listener_tmp , view.getHandler());
    }

    
    
    
    
    
}